const n = {
  merge: (r, e, t) => {
    if (!r && !e)
      return {};
    if (!r)
      return e;
    if (!e)
      return r;
    if (t != null && t.preserve) {
      const o = n.overlaps(r, e), i = n.omit(e, o);
      return { ...r, ...i };
    }
    return { ...r, ...e };
  },
  omit(r, e) {
    const t = {};
    for (const s in r)
      e.includes(s) || (t[s] = r[s]);
    return t;
  },
  pick(r, e) {
    const t = {};
    for (const s of e)
      t[s] = r[s];
    return t;
  },
  overlaps(r, e) {
    const t = Object.keys(r), s = Object.keys(e);
    return t.filter((i) => s.includes(i));
  },
  seialize(r) {
    return JSON.stringify(r);
  },
  deserialize(r) {
    try {
      return JSON.parse(r);
    } catch {
      throw "Invalid JSON";
    }
  },
  validate: {
    notNull: (r, e, t) => {
      r == null && (t == null || t.push("Validation Error: " + e));
    },
    string: (r, e, t) => {
      typeof r != "string" && (t == null || t.push("Validation Error: " + e));
    },
    object: (r, e, t) => {
      typeof r != "object" && (t == null || t.push("Validation Error: " + e));
    },
    number: (r, e, t) => {
      typeof r != "number" && (t == null || t.push("Validation Error: " + e));
    },
    notEmpty: (r, e, t) => {
      (!r || r.length === 0) && (t == null || t.push("Validation Error: " + e));
    }
  },
  throwErr: (r) => {
    throw r[0];
  },
  getValue: (r, e, t) => r[e] === void 0 ? t || null : r[e],
  /**
   * If the args is an array, it returns the array, otherwise it returns an array with the args as the only element
   */
  asArray(r) {
    return Array.isArray(r) ? r : [r];
  }
};
class c {
  constructor(e) {
    this.meta = {}, this.config = e.config, this.name = e.name, this.description = e.description, this.meta = e.meta, this.resources = Object.keys(e.config), this.permissions = this.init(e.config, this.resources);
  }
  getDefaultPermission(e) {
    return {
      c: "create",
      r: "read",
      u: "update",
      d: "delete",
      l: "list"
    }[e];
  }
  init(e, t) {
    const s = {};
    for (const o of t) {
      const i = e[o].scopes, a = e[o].custom, f = new Set(i), u = {};
      for (const h of ["c", "r", "u", "d", "l"])
        u[this.getDefaultPermission(h)] = f.has(h);
      s[o] = n.merge(
        u,
        a
      );
    }
    return s;
  }
  getPermissions() {
    return this.permissions;
  }
  getResources() {
    return this.resources;
  }
  add(e) {
    const { permissions: t, resource: s, mutate: o, noOverride: i } = e;
    return o ? (this.config = n.merge(
      this.config,
      {
        [s]: t
      },
      {
        preserve: i
      }
    ), this.permissions = this.init(this.config, this.resources), this) : new c({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: n.merge(
        this.config,
        {
          [s]: t
        },
        {
          preserve: i
        }
      )
    });
  }
  // eslint-disable-next-line @typescript-eslint/ban-types
  remove(e) {
    const { resource: t, mutate: s } = e;
    return s ? (delete this.config[t], delete this.permissions[t], this) : new c({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: n.omit(this.config, [t])
    });
  }
  // eslint-disable-next-line @typescript-eslint/ban-types
  update(e) {
    const { permissions: t, resource: s, mutate: o, noOverride: i } = e;
    return o ? (this.config = n.merge(
      this.config,
      {
        [s]: t
      },
      {
        preserve: i
      }
    ), this.permissions = this.init(this.config, this.resources), this) : new c({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: n.merge(
        this.config,
        {
          [s]: t
        },
        {
          preserve: i
        }
      )
    });
  }
  can(e, t) {
    const o = new Map(Object.entries(this.getPermissions())).get(e);
    return o ? o[t] : !1;
  }
  cannot(e, t) {
    return !this.can(e, t);
  }
  canAny(e, t) {
    return t.some((s) => this.can(e, s));
  }
  canAll(e, t) {
    return t.every((s) => this.can(e, s));
  }
  clone() {
    return new c({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: this.config
    });
  }
  toJSON() {
    return n.seialize({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: this.config
    });
  }
  toObject() {
    return {
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: this.config,
      permissions: this.permissions,
      resources: this.resources
    };
  }
  /**
   *  Creates a role from a JSON string
   */
  static fromJSON(e) {
    const t = n.deserialize(e);
    return this.fromObject(t);
  }
  /**
   *  Creates a role from object
   */
  static fromObject(e) {
    const t = this.validate(e);
    return t.length ? n.throwErr(t) : new c({
      config: e.config,
      description: e.description,
      meta: e.meta,
      name: e.name
    });
  }
  static validate(e, t) {
    const { name: s, config: o } = e, i = [];
    return n.validate.notEmpty(Object.keys(e), "Role must not be empty", i), n.validate.notNull(s, "Name of the role is required", i), n.validate.string(s, "Name of the role must be a string", i), n.validate.notNull(o, "Config of the role is required", i), n.validate.object(o, "Config of the role must be an object", i), t && t(i.length === 0, i), i;
  }
}
class l {
  constructor(e) {
    this.schema = e;
  }
  _verifyPermissionsLoose(e, t, s) {
    return s.some((o) => t.some((i) => e.can(i, o)));
  }
  _verifyPermissionsStrict(e, t, s) {
    return s.every((o) => t.every((i) => e.can(i, o)));
  }
  _getRole(e) {
    return this.schema.getRole(e);
  }
  _construct(e) {
    if (typeof e == "string")
      return c.fromJSON(e);
    if (typeof e == "object")
      return c.fromObject(e);
    throw "Invalid argument for `_construct` method";
  }
  authorize(e) {
    if ("role" in e) {
      const t = this._getRole(e.role);
      return e.strict ? this._verifyPermissionsStrict(
        t,
        n.asArray(e.resources),
        n.asArray(e.actions)
      ) : this._verifyPermissionsLoose(
        t,
        n.asArray(e.resources),
        n.asArray(e.actions)
      );
    }
    if ("construct" in e) {
      const t = this._construct(e.data);
      return e.strict ? this._verifyPermissionsStrict(
        t,
        n.asArray(e.resources),
        n.asArray(e.actions)
      ) : this._verifyPermissionsLoose(
        t,
        n.asArray(e.resources),
        n.asArray(e.actions)
      );
    }
    throw "Invalid argument for `authorize` method";
  }
}
class d {
  constructor(e) {
    this.roles = e;
  }
  getRole(e) {
    return this.roles[e];
  }
  getResources() {
    const e = {};
    for (const t in this.roles) {
      const s = this.roles[t].permissions;
      for (const o in s)
        e[o] = o;
    }
    return e;
  }
}
class m extends Error {
  constructor(e) {
    super(e), this.code = e;
  }
  static throw_error(e) {
    throw new m(e);
  }
  static throw_unknown_error(e) {
    throw Error(e);
  }
}
export {
  m as AuthError,
  l as AuthManager,
  c as Role,
  d as Schema
};
