import { ISchema, MergePermissions } from '../types';
import Role from './role';
/**
 * Auth schema
 */
declare class Schema<T extends {
    [K in keyof T]: T[K] extends Role<infer U> ? Role<U> : never;
}> implements ISchema<T> {
    roles: T;
    constructor(roles: T);
    getRole<K extends keyof T>(name: K): T[K];
    getResources(): Record<keyof MergePermissions<T>, keyof MergePermissions<T>>;
}
export default Schema;
